#include <graphics.h>
#include <iostream>

using namespace std;

int random(int maxr)
{
    int r;
       /* random int between minr and maxr */
       r = (rand() % maxr);
    
 return r;
}

int random(int minr,int maxr)
{
    int r;
       /* random int between minr and maxr */
       r = minr+(rand() % maxr);
    
 return r;
}

uint16_t analogRead(int PIN)
{
         if ((GetAsyncKeyState(VK_UP) < 0) && PIN==0 )
         {
                return 10000;
         }
         else if ((GetAsyncKeyState(VK_DOWN) < 0) && PIN==0 )
         {
                return 1;
         }
         else if ((GetAsyncKeyState(VK_LEFT)  < 0) && PIN==1 )
         {
                return 10000;
         }
         else if ((GetAsyncKeyState(VK_RIGHT)   < 0) && PIN==1 )
         {
                return 1;
         }
         return 500;        
}

class SerialCL {
      public:
      void begin(int baud);
      };

void SerialCL::begin(int baud)
{
 
}

class TVout {
      int with,height;
      public:
         void set_pixel(int,int,int);
         void begin(int ntsc, int x, int y);
         void clear_screen();
         void delay_frame(int frame);
         void draw_circle(int x, int y, int r,int c);
         void bitmap(int x, int y, const unsigned char*);
         int hres();
         int vres();
         int scale;
         void draw_rect(uint8_t &x, uint8_t &y, int xx, int yy,colors c1,colors c2);
      };
      
void TVout::begin(int ntsc, int x, int y){
    with=x;
    height=y;
    initwindow(with*scale,height*scale);
     }

void TVout::bitmap(int xorg, int yorg, const unsigned char* a){
    unsigned int width,hight;
    unsigned int bits;
    int i,x,y,m,sc_i;
    width=a[0];
    hight=a[1];
    bits=128;
    i=2;
    y=yorg*scale;
    do  
    {
     for(sc_i=0;sc_i<scale;sc_i++)
     {
       x=xorg*scale;
       do
       {                   
         if((a[i] & bits)==bits) 
         {      
           for(m=0;m<scale;m++)
           {
              putpixel(x,y,2);
              x++;
           } 
         }
         else
         {      
           for(m=0;m<scale;m++)
           {
              putpixel(x,y,1);
              x++;
           } 
         }
     
         bits=bits/2;
         if (bits<0.75)
         {
            i=i+1;
            bits=128;
         }
      } while(x<(xorg*scale+width*scale));
      i=i-1;
      y++;
     } // end for
     i++;
   }  while(y<(yorg*scale+hight*scale));
   
}
     
void TVout::set_pixel(int x, int y, int c){
    putpixel(x*scale,y*scale,c);
}  

void TVout::draw_circle(int x, int y, int r,int c){
     setcolor( c );
    circle( x*scale, y*scale, r*scale );
}    
    
void TVout::draw_rect(uint8_t &x, uint8_t &y, int xx, int yy,colors c1,colors c2)
{
    rectangle( x*scale, y*scale, xx*scale, yy*scale );
}    
     
void TVout::clear_screen(){
    cleardevice();
}

void TVout::delay_frame(int frame){
    
}

int TVout::hres(){
                 return with;
                 }
                 
int TVout::vres(){
                 return height;
                 }
                 
