#include <graphics.h>
#include <iostream>

#define NTSC 1

using namespace std;

uint16_t analogRead(int PIN);

int random(int maxr);
int random(int minr,int maxr);

class SerialCL {
      public:
      void begin(int baud);
      };
      
class TVout {
      int with,height;
      public:
         void set_pixel(int,int,int);
         void begin(int ntsc, int x, int y);
         void clear_screen();
         void delay_frame(int frame);
         void draw_circle(int x, int y, int r,int c);
         void bitmap(int x, int y, const unsigned char*);
         void draw_rect(uint8_t &x, uint8_t &y, int xx, int yy,colors c1,colors c2);
         int hres();
         int vres();
         int scale;
         };
  
